       >>SOURCE FORMAT IS FIXED
      *> ***************************************************************
      *><* ================
      *><* test recursive subpromag usage (with sequential file I/O).
      *><* ================
      *><* :Author:    Fred
      *><* :Date:      02-03-2012
      *><* :Purpose:   Read the cmdline argument for a file which
      *><*             contains at least a record with the name of
      *><*             another file.
      *><* :Tectonics: cobc -x recursiveprog.cob
      *> ***************************************************************
       identification division.
       program-id. recursiveprog.
       environment division.
       configuration section.
       data division.
 
       working-storage section.
       01  program-name               pic x(0015) value "recursiveprog".
       01  programversion              pic x(0008) value "0.0.1".
       01  programcompiled             pic x(0010) value "02/03/2012".
       01  filler.
           03  nbr-of-cmdlineargs      pic 9(05).
       	   03  actual-cmdlinearg-nbr   pic 9(05).
       01  actual-cmdlinearg1                   value spaces.
       	   03  filler                  pic x(0128).

       procedure division.
       mainline section.
       p00.
           accept nbr-of-cmdlineargs from argument-number
           move 1 to actual-cmdlinearg-nbr
           accept actual-cmdlinearg1 from argument-value
           display "File to process: " actual-cmdlinearg1
           call "recursivesub" 
               using actual-cmdlinearg1
               .
       peos.
           stop run.
       end program recursiveprog.


       >>SOURCE FORMAT IS FIXED
       identification division.
       program-id. recursivesub is recursive.
       environment division.
       input-output section.
       file-control.
          select infile  assign to "infile"
              organization is line sequential 
              access mode is sequential
              .
       data division.
       file section.
       fd infile
           record is varying in size
           depending on rec-length-in.
       01  rec-in-record.
           03  rec-in-byte             pic x(0001) occurs 256.
 
       working-storage section.
       01  program-namex               pic x(0015) value "recursivesub".
       01  programversionx             pic x(0008) value "0.0.1".
       01  programcompiledx            pic x(0010) value "02-03-2012".
       01  filler.
           03  rec-length-in           pic 9(05) comp.
           03  ws-out-nbr              pic 9(05) comp value 0.
           03  ws-out-data.
               05  ws-out-byte         pic x(0001) occurs 248.
           03  filler redefines ws-out-data.
               05  ws-out-ident        pic x(0001).
               05  ws-out-text         pic x(0247).
           03  filler redefines ws-out-data.
               05  ws-out-source       pic x(0048).
               05  filler              pic x(0100).
       01  ws-switches.
           03  sw-eof-input            pic x(0001)  value low-values.
             88   eof-input                         value high-value.
       01  ws-namefound                pic x(0128).
       linkage section.
       01  actual-cmdlinearg1          pic x(0128)  value spaces.
      *> ***************************************************************
       procedure division
           using actual-cmdlinearg1
           .
       mainline section.
       p00.
           display "Sub: to process  " actual-cmdlinearg1
           perform read-seq-file
               .
       peos.
           exit program.
       read-seq-file section.
       p00.
           set environment "DD_infile" to actual-cmdlinearg1
           open input infile
           perform read-seq-record
               until eof-input
           close infile
               .
       peos.
           exit.
       read-seq-record section.
       p00.
           read infile
               into ws-out-data
               at end
                   move high-value to sw-eof-input
                   go to peos    
               .
           display "text: " ws-out-source
           if ws-out-ident not = "#"
               move ws-out-source to ws-namefound
               display "Next file to process: " ws-namefound
               call "recursivesub"
                   using ws-namefound
               .
       peos.
           exit.
       end program recursivesub.
